﻿@using Services;
@inject ConvertService convertService

<div>
    <EditForm Model="@DummyModel">
        <div class="form-group">
            <h6>% Amount = Amount * (% / 100)</h6>
            <label class="mr-sm-2">Select any 2 (Can select only 2, deselect one to select another)</label>
        </div>
        <div class="form-group">
            <table class="table table-hover table-sm">
                <tbody>
                    <tr>
                        <td>Amount</td>
                        <td>
                            <div class="input-group">
                                <div class="input-group-prepend">
                                    <div class="input-group-text">
                                        <input type="checkbox" @bind="EnabledAmount" />
                                    </div>
                                </div>
                                <input class="form-control form-control-sm mr-sm-2" value="@Amount" @oninput="((ChangeEventArgs __e) => Amount = ToDouble(__e?.Value))" disabled="@(!EnabledAmount)" maxlength="12" />
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <td>%</td>
                        <td>
                            <div class="input-group">
                                <div class="input-group-prepend">
                                    <div class="input-group-text">
                                        <input type="checkbox" @bind="EnabledPercentage" />
                                    </div>
                                </div>
                                <input class="form-control form-control-sm mr-sm-2" value="@Percentage" @oninput="((ChangeEventArgs __e) => Percentage = ToDouble(__e?.Value))" disabled="@(!EnabledPercentage)" maxlength="6" />
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <td>% Amount</td>
                        <td>
                            <div class="input-group">
                                <div class="input-group-prepend">
                                    <div class="input-group-text">
                                        <input type="checkbox" @bind="EnabledPercentageAmount" />
                                    </div>
                                </div>
                                <input class="form-control form-control-sm mr-sm-2" value="@PercentageAmount" @oninput="((ChangeEventArgs __e) => PercentageAmount = ToDouble(__e?.Value))" disabled="@(!EnabledPercentageAmount)" maxlength="12" />
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <td>Amount + % Amount</td>
                        <td>
                            <div class="input-group">
                                <div class="input-group-prepend">
                                    <div class="input-group-text">
                                        <input type="checkbox" @bind="EnabledPercentageAddAmount" />
                                    </div>
                                </div>
                                <input class="form-control form-control-sm mr-sm-2" value="@PercentageAddAmount" @oninput="((ChangeEventArgs __e) => PercentageAddAmount = ToDouble(__e?.Value))" disabled="@(!EnabledPercentageAddAmount)" maxlength="12" />
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <td>Amount - % Amount</td>
                        <td>
                            <div class="input-group">
                                <div class="input-group-prepend">
                                    <div class="input-group-text">
                                        <input type="checkbox" @bind="EnabledPercentageSubAmount" />
                                    </div>
                                </div>
                                <input class="form-control form-control-sm mr-sm-2" value="@PercentageSubAmount" @oninput="((ChangeEventArgs __e) => PercentageSubAmount = ToDouble(__e?.Value))" disabled="@(!EnabledPercentageSubAmount)" maxlength="12" />
                            </div>
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>
    </EditForm>
</div>

@code {

    private string DummyModel { get; set; } = string.Empty;

    private bool EnabledAmount { get; set; } = false;
    private double Amount { get; set; } = 0;
    private bool EnabledPercentage { get; set; } = false;
    private double Percentage { get; set; } = 0;
    private bool EnabledPercentageAmount { get; set; } = false;
    private double PercentageAmount { get; set; } = 0;
    private bool EnabledPercentageAddAmount { get; set; } = false;
    private double PercentageAddAmount { get; set; } = 0;
    private bool EnabledPercentageSubAmount { get; set; } = false;
    private double PercentageSubAmount { get; set; } = 0;

    protected override bool ShouldRender()
    {
        RefreshValues();
        bool shouldRender = base.ShouldRender();
        return shouldRender;
    }

    private double ToDouble(object value) => convertService.ToDouble(value);

    private string ToIndianCurrency(double value) => convertService.ToIndianCurrency(value, false, false);

    private void RefreshValues()
    {
        int enabledCount = GetEnabledInputCount();
        if (enabledCount >= 2)
        {
            ResetEnabledCount();
            Calculate();
        }
        else
        {
            if (!EnabledAmount) Amount = 0;
            if (!EnabledPercentage) Percentage = 0;
            if (!EnabledPercentageAmount) PercentageAmount = 0;
            if (!EnabledPercentageAddAmount) PercentageAddAmount = 0;
            if (!EnabledPercentageSubAmount) PercentageSubAmount = 0;
        }
    }

    private int GetEnabledInputCount()
    {
        int enabledCount = 0;
        if (EnabledAmount) enabledCount++;
        if (EnabledPercentage) enabledCount++;
        if (EnabledPercentageAmount) enabledCount++;
        if (EnabledPercentageAddAmount) enabledCount++;
        if (EnabledPercentageSubAmount) enabledCount++;
        return enabledCount;
    }

    private void ResetEnabledCount()
    {
        int enabledCount;
        do
        {
            enabledCount = GetEnabledInputCount();
            if (enabledCount > 2)
            {
                if (EnabledPercentageSubAmount) { EnabledPercentageSubAmount = !EnabledPercentageSubAmount; continue; }
                if (EnabledPercentageAddAmount) { EnabledPercentageAddAmount = !EnabledPercentageAddAmount; continue; }
                if (EnabledPercentageAmount) { EnabledPercentageAmount = !EnabledPercentageAmount; continue; }
                if (EnabledPercentage) { EnabledPercentage = !EnabledPercentage; continue; }
                if (EnabledAmount) { EnabledAmount = !EnabledAmount; continue; }
            }
        } while (enabledCount > 2);
    }

    private void Calculate()
    {
        // Amount check
        if (EnabledAmount && EnabledPercentage)
        {
            PercentageAmount = Math.Round(Amount * (Percentage / 100), 2);
        }
        else if (EnabledAmount && EnabledPercentageAmount)
        {
            Percentage = Amount > 0 ? Math.Round((PercentageAmount / Amount) * 100, 2) : 0;
        }
        else if (EnabledAmount && EnabledPercentageAddAmount)
        {
            PercentageAmount = PercentageAddAmount - Amount;
            Percentage = Amount > 0 ? Math.Round((PercentageAmount / Amount) * 100, 2) : 0;
        }
        else if (EnabledAmount && EnabledPercentageSubAmount)
        {
            PercentageAmount = Amount - PercentageSubAmount;
            Percentage = Amount > 0 ? Math.Round((PercentageAmount / Amount) * 100, 2) : 0;
        }
        // Percentage check
        else if (EnabledPercentage && EnabledPercentageAmount)
        {
            if (Percentage > 0)
                Amount = Math.Round((PercentageAmount / Percentage) * 100, 2);
            else
                Amount = 0;
        }
        else if (EnabledPercentage && EnabledPercentageAddAmount)
        {
            if (Percentage > 0)
                Amount = Math.Round(PercentageAddAmount / (1 + (Percentage / 100)), 2);
            else
                Amount = 0;
            PercentageAmount = PercentageAddAmount - Amount;
        }
        else if (EnabledPercentage && EnabledPercentageSubAmount)
        {
            if (Percentage > 0)
                Amount = Math.Round(PercentageSubAmount / (1 - (Percentage / 100)), 2);
            else
                Amount = 0;
            PercentageAmount = Amount - PercentageSubAmount;
        }
        // Percentage amount check
        else if (EnabledPercentageAmount && EnabledPercentageAddAmount)
        {
            Amount = PercentageAddAmount - PercentageAmount;
            Percentage = Amount > 0 ? Math.Round((PercentageAmount / Amount) * 100, 2) : 0;
        }
        else if (EnabledPercentageAmount && EnabledPercentageSubAmount)
        {
            Amount = PercentageAmount + PercentageSubAmount;
            Percentage = Amount > 0 ? Math.Round((PercentageAmount / Amount) * 100, 2) : 0;
        }
        // Percentage amount add check
        else if (EnabledPercentageAddAmount && EnabledPercentageSubAmount)
        {
            PercentageAmount = Math.Round((PercentageAddAmount - PercentageSubAmount) / 2, 2);
            Amount = PercentageAddAmount - PercentageAmount;
            Percentage = Amount > 0 ? Math.Round((PercentageAmount / Amount) * 100, 2) : 0;
        }

        if (PercentageAmount > 0)
        {
            if (!EnabledPercentageAddAmount)
                PercentageAddAmount = Amount + PercentageAmount;
            if (!EnabledPercentageSubAmount)
                PercentageSubAmount = Amount - PercentageAmount;
        }
    }

}
